--[[
	Capship Tab written by Seryn
	version 1.1.0
	based on mdi-targetlist tab system by draugath
--]]

declare("Capship_tab", {
	version = "1.0.0",
})


local T = {
	Tab = {
		title = "Capship",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Commands",
				width = 1,
			},
		},
		filters = {
			{
				title = "Commands",
			},
			{
				title = "PVE",
			},
			{
				title = "Features",
			},
			{
				title = "Turrets",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Capship_tab.T = T
T.Tab.mainCommandList = {
	{
		"1",
		"\127ffff8c** Follow ME",
	},
	{
		"2",
		"\12772ddf7** Follow Target",
	},
	{ 
		"3",
		"\127ffff8c** Park",
	},
	{	
		"4",
		"\12772ddf7** Turbo",
	},
	{	
		"5",
		"\127ffff8c** Shield",
	},
	{	
		"6",
		"\12772ddf7** Attack Target",
	},
	{	
		"7",
		"\127ffff8c** Defend Target",
	},
	{	
		"8",
		"\12772ddf7** Patrol",
	},
	{	
		"9",
		"\127ffff8c** Cease Fire",
	}
}
T.Tab.pveCommandList = {
	{
		"1",
		"\127ffff8c** Follow ME",
	},
	{
		"2",
		"\12772ddf7** Follow Target",
	},
	{ 
		"3",
		"\127ffff8c** Park",
	},
	{	
		"4",
		"\12772ddf7** Prepare for docking",
	},
	{	
		"5",
		"\127ffff8c** Mine",
	},
	{	
		"6",
		"\12772ddf7** Gather Target Ore",
	},
}
T.Tab.otherList = {
	{
		"1",
		"\127ffff8c** Autocontrol on docking ON/OFF",
	},
	{
		"2",
		"\12787bba2** Switch Control Trident/Goliath",
	},
	{
		"3",
		"\127ffff8c** Give Capship Key",
	},
	{ 
		"4",
		"\12787bba2** Revoke Capship Key",
	},
	{	
		"5",
		"\127ffff8c** Plot Route to Capship",
	},
	{	
		"6",
		"\12787bba2** Kick All Gunners",
	},
	{	
		"7",
		"\127ffff8c** Dismiss All Gunners",
	},
	
}
T.Tab.turretList = {
	{	
		"1",
		"\127ffff8c** Undock Ship 1",
	},
	{	
		"2",
		"\127a53860** Undock Ship 2",
	},
	{	
		"3",
		"\127ffff8c** Undock Ship 3",
	},
	{	
		"4",
		"\127a53860** Undock Ship 4",
	},
	{	
		"5",
		"\127ffff8c** Undock Ship 5",
	},
	{	
		"6",
		"\127a53860** Undock Ship 6",
	},
	{	
		"7",
		"\127f9dcc4** Enter Turret 1",
	},
	{	
		"8",
		"\127748cab** Enter Turret 2",
	},
	{	
		"9",
		"\127f9dcc4** Enter Turret 3",
	},
	{	
		"10",
		"\127748cab** Enter Turret 4",
	},
}



T.Tab.ship = {}
T.Tab.ship.nameTrident = " "
T.Tab.ship.nameGoliath = " "
T.Tab.ship.TridentKey = " "
T.Tab.ship.GoliathKey = " "
T.Tab.ship.controlTrident = true
T.Tab.ship.controlGoliath = false
T.Tab.ship.autocontrolCapship = false
T.Tab.systemnotes = 1120003470



-- save/edit values to system notes
function T.Tab.savemsg(data, args)
    if args then 
        -- syntax cmd, name, "ship name"
		-- save name for trident 
        if args[1]:lower() == "tridentname" then
            local msg = args[2]
			T.Tab.ship.controlTrident = true
			T.Tab.ship.controlGoliath = false
			T.Tab.ship.nameTrident = msg
			local printstr = "\127ffff8cCapship name saved: "  .. msg .. ". Capship control set to: \127o" .. "\127ff0000Trident.\127o";
            print(printstr)
        -- save name for goliath
		elseif args[1]:lower() == "goliathname" then
            local msg = args[2]
			T.Tab.ship.controlTrident = false
			T.Tab.ship.controlGoliath = true
            T.Tab.ship.nameGoliath = msg
            local printstr = "\127ffff8cCapship name saved: "  .. msg .. ". Capship control set to: \127o" .. "\127ff0000Goliath.\127o";
            print(printstr)
		-- save key for trident
		elseif args[1]:lower() == "tridentkey" then
			local keyID = args[2]
			T.Tab.ship.TridentKey = keyID
			print("\127ffff8cKey ID " .. keyID .. " saved as user key for your Trident.\127o")
		-- save key for goliath
		elseif args[1]:lower() == "goliathkey" then
			local keyID = args[2]
			T.Tab.ship.GoliathKey = keyID
			print("\127ffff8cKey ID " .. keyID .. " saved as user key for your Goliath\127o")
		else
			print("\127ffff8cInvalid command. Please refer to the README file for valid options.\127o")
        end
        -- write data to systemnotes
        SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)
    end
end



-- tab change to capship tab, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	if self.filter_index == 1 then
		T.Tab.currentList = T.Tab.mainCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.pveCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.otherList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 4 then
		T.Tab.currentList = T.Tab.turretList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

-- 
function T.Tab:ChangeTarget(_, listEntryID)
	
	
	local listEntryID = listEntryID
	
	if self.filter_index == 1 then
		T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local shipName = ""
			if T.Tab.ship.controlTrident == true then
				shipName = T.Tab.ship.nameTrident
			elseif T.Tab.ship.controlGoliath == true then 
				shipName = T.Tab.ship.nameGoliath
			else
				print("\127ffff8cNo Capship specified. Please setup the Capship Tab with /capshipsetup \127o")
			end
		-- /msg shipname follow
		if listEntryID == 1 then
			local msg = "follow"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname follow targetname
		elseif listEntryID == 2 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			
			if targetName ~= nil then 
				local msg = "follow " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\127ffff8cAsteroid too slow. The pilot is at risk of falling asleep while following, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\127ffff8cCargo crates can\'t fly. Please target a player to follow.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname park
		elseif listEntryID == 3 then
			local msg = "park";
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname turbo
		elseif listEntryID == 4 then
			local msg = "turbo"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname shield
		elseif listEntryID == 5 then
			local msg = "shield"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname attack targetname
		elseif listEntryID == 6 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then
				local msg = "attack " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\127ffff8cAsteroids don't make good targets. Find something more challenging to shoot and please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\127ffff8cCargo crates make lame opponents. Please target a capship to attack.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname defend targetname
		elseif listEntryID == 7 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then 
				local msg = "defend " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\127ffff8cCapship unwilling to sacrifice itself to save an asteroid, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\127ffff8cJust scoop the cargo, there is no need to defend it. Please target a player to defend.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname patrol
		elseif listEntryID == 8 then
			local msg = "patrol"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname cease fire
		elseif listEntryID == 9 then
			local msg = "cease fire"
			SendChat(msg, "PRIVATE", shipName)

		--
		elseif listEntryID == 10 then
			return
		end

	-- pve tab
	elseif self.filter_index == 2 then
		T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local shipName = ""
			if T.Tab.ship.controlTrident == true then
				shipName = T.Tab.ship.nameTrident
			elseif T.Tab.ship.controlGoliath == true then 
				shipName = T.Tab.ship.nameGoliath
			else
				print("\127ffff8cNo Capship specified. Please setup the Capship Tab with /capshipsetup \127o")
			end
		-- /msg shipname follow
		if listEntryID == 1 then
			local msg = "follow"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname follow targetname
		elseif listEntryID == 2 then
			local targetName, _, _, _, _, _ = GetTargetInfo()
			if targetName ~= nil then
				local msg = "follow " .. targetName
				if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
					print("\127ffff8cAsteroid too slow. The pilot is at risk of falling asleep while following, please target a player.\127o")
				elseif targetName:match("cu%)") then
					print("\127ffff8cCargo crates can\'t fly. Please target a player to follow.\127o")
				else
					SendChat(msg, "PRIVATE", shipName)
				end
			end

		-- /msg shipname park
		elseif listEntryID == 3 then
			local msg = "park";
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname prepare for docking
		elseif listEntryID == 4 then
			local msg = "prepare for docking"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname mine
		elseif listEntryID == 5 then
			local msg = "mine"
			SendChat(msg, "PRIVATE", shipName)

		-- /msg shipname gather targetore
		elseif listEntryID == 6 then
			local targetOre = GetTargetInfo()
			if targetOre ~= nil then
				if targetOre:match("Premium") then
					local split, rest = string.match(targetOre, "(.*)Ore(.*)")
					local searchOre = string.sub(split, 9)
					local msg = "gather " .. searchOre;
					SendChat(msg, "PRIVATE", shipName)
				else
					local split, rest = string.match(targetOre, "(.*)Ore(.*)")
					local searchOre = split
					local msg = "gather " .. searchOre;
					SendChat(msg, "PRIVATE", shipName)
				end
			end
		elseif listEntryID == 7 then
			return
		elseif listEntryID == 8 then
			return
		elseif listEntryID == 9 then
			return
		elseif listEntryID == 10 then
			return
		end

	-- management tab
	elseif self.filter_index == 3 then
		-- autocontrol when docking
		if listEntryID == 1 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			if T.Tab.ship.autocontrolCapship == false then
				T.Tab.ship.autocontrolCapship = true
				print("\127ffff8cAutocontrol for capship is ON.\127o")
			else
				T.Tab.ship.autocontrolCapship = false
				print("\127ffff8cAutocontrol for Capship is OFF.\127o")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- switch between capships to control via the capship tab
		elseif listEntryID == 2 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));

			local nameGoliath = T.Tab.ship.nameGoliath or "None"
			local nameTrident = T.Tab.ship.nameTrident or "None"

			if (T.Tab.ship.controlTrident == true) and (nameGoliath ~= " " or "None") then
				T.Tab.ship.controlTrident = false
				T.Tab.ship.controlGoliath = true
				print("\127ffff8cCapship Control now set to: " .. nameGoliath .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == true) and (nameGoliath == " " or "None") then
				T.Tab.ship.controlTrident = true
				T.Tab.ship.controlGoliath = false
				print("\127ffff8cNo Goliath assigned. Capship Control now set to: " .. nameTrident .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == false) and (nameTrident ~= " " or "None") then
				T.Tab.ship.controlTrident = true
				T.Tab.ship.controlGoliath = false
				print("\127ffff8cCapship Control now set to: " .. nameTrident .. "\127o")
				
			elseif (T.Tab.ship.controlTrident == false) and (nameTrident == " " or "None") then
				T.Tab.ship.controlTrident = false
				T.Tab.ship.controlGoliath = true
				print("\127ffff8cNo Trident assigned. Capship Control now set to: " .. nameGoliath .. "\127o")
				
			else
				print("Error! Capship not assigned.")
			end
			SaveSystemNotes(spickle(T.Tab.ship), T.Tab.systemnotes)

		-- give user key to target
		elseif listEntryID == 3 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local targetName = GetTargetInfo()
			if targetName ~= nil then 
				local keyID = "None"
				if T.Tab.ship.controlTrident == true then
					keyID = T.Tab.ship.TridentKey
				elseif T.Tab.ship.controlGoliath == true then 
					keyID = T.Tab.ship.GoliathKey
				end
				if keyID == "None" or nil then
					print("\127ffff8cNo capship key assigned. Please use /capshipsetup\127o")
				else
					Keychain.giveuserkey(targetName, keyID)
					print("\127ffff8cCapship key given to: " .. targetName .. "\127o")
				end
			else 
				print("\127ffff8cNo target specified.\127o")
			end

		-- revoke user key of target
		elseif listEntryID == 4 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local targetName = GetTargetInfo()
			local keyID = "None"
			if targetName ~= nil then
				if T.Tab.ship.controlTrident == true then
					keyID = T.Tab.ship.TridentKey
				elseif T.Tab.ship.controlGoliath == true then 
					keyID = T.Tab.ship.GoliathKey
				end
				if keyID == "None" or nil then
					print("\127ffff8cNo capship key assigned. Please use /capshipsetup\127o")
				else
					Keychain.revokekey(targetName, keyID)
					print("\127ffff8cCapship key revoked for: " .. targetName .. "\127o")
				end
			else
				print("\127ffff8cNo target specified.\127o")
			end

		-- plot to your capship
		elseif listEntryID == 5 then
			T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
			local stationID = " "
			local sectorID = " "
			local capLocation = " "
			local currentCapship = " "
			if T.Tab.ship.controlTrident == true then
				currentCapship = "Trident Type M"
			elseif T.Tab.ship.controlGoliath == true then
				currentCapship = "Goliath"
			else
				print("\127ffff8cError! No capship to control assigned.\127o")
			end
			
			for itemID, _ in PlayerInventoryPairs() do
				local _, shipName, _, _, shipType, _, _, containerID, _, _ = GetInventoryItemInfo(itemID)
				if shipType:match(currentCapship) and containerID > 0 then -- found a capship!
					stationID = GetInventoryItemLocation(itemID)
					sectorID = GetSectorIDOfStation(stationID)
					capLocation = AbbrLocationStr(sectorID)
				end
			end
			NavRoute.SetFinalDestination(sectorID)
			print("\127ff7566Navroute set to: " .. capLocation .. "\127o")

		-- kick all gunners
		elseif listEntryID == 6 then
			local numberOfTurrets = GetNumStationTurrets()
			local turretID = 1
			local turretInfo = {}
			local ownCharID = GetCharacterID()
			if numberOfTurrets == 0 or nil then
				print("\127ffff8cYour ship has no Turrets!\127o")
			else
				while turretID <= numberOfTurrets do
					local turretInfo = GetStationTurretInfo(turretID)
					local gunnerCharID = turretInfo.controller
					if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
						Gunner.Kick(GetPlayerName(gunnerCharID))
					end
					turretID = turretID + 1
				end
				print("\127ffff8cAll gunners ejected from the ship.\127o")
			end

		-- dismiss all gunners
		elseif listEntryID == 7 then
			local numberOfTurrets = GetNumStationTurrets()
			local turretID = 1
			local turretInfo = {}
			local gunnerCharID = 0
			local ownCharID = GetCharacterID()
			if numberOfTurrets == 0 then
				print("\127ffff8cYour ship has no Turrets!\127o")
			else
				while turretID <= numberOfTurrets do
					turretInfo = GetStationTurretInfo(turretID)
					gunnerCharID = turretInfo.controller
					if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
						Gunner.Dismiss(GetPlayerName(gunnerCharID))
					end
					turretID = turretID + 1
				end
				print("\127ffff8cAll gunners dismissed from their turrets.\127o")
			end
		--
		elseif listEntryID == 8 then
			return
		--
		elseif listEntryID == 9 then
			return
		--
		elseif listEntryID == 10 then
			return
		end


	-- turret options tab
	elseif self.filter_index == 4 then
		-- undock first stored ship
		if listEntryID == 1 then
			local shipList = GetShipList()
			if shipList[1] ~= nil then
			print("\127ffff8cShip #1 found. Undocking...\127o") 
			RequestLaunch(GetShipList()[1])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end
			
		-- undock second stored ship
		elseif listEntryID == 2 then
			local shipList = GetShipList()
			if shipList[2] ~= nil then
				print("\127ffff8cShip #2 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[2])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end
			
		-- undock third stored ship
		elseif listEntryID == 3 then
			local shipList = GetShipList()
			if shipList[3] ~= nil then
				print("\127ffff8cShip #3 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[3])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end
		-- undock fourth stored ship
		elseif listEntryID == 4 then
			local shipList = GetShipList()
			if shipList[4] ~= nil then
				print("\127ffff8cShip #4 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[4])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end
		-- undock fifth stored ship
		elseif listEntryID == 5 then
			local shipList = GetShipList()
			if shipList[5] ~= nil then
				print("\127ffff8cShip #5 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[5])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end

		-- undock sixth stored ship
		elseif listEntryID == 6 then
			local shipList = GetShipList()
			if shipList[6] ~= nil then
				print("\127ffff8cShip #6 found. Undocking...\127o") 
				RequestLaunch(GetShipList()[6])
			else
				print("\127ffff8cThe requested Ship is not here. Did you misplace it?\127o")
			end

		-- enter turret 1
		elseif listEntryID == 7 then
			gkinterface.GKProcessCommand("enterturret 1")

		-- enter turret 2
		elseif listEntryID == 8 then
			gkinterface.GKProcessCommand("enterturret 2")

		-- enter turret 3
		elseif listEntryID == 9 then
			gkinterface.GKProcessCommand("enterturret 3")

		-- enter turret 4
		elseif listEntryID == 10 then
			gkinterface.GKProcessCommand("enterturret 4")
		end

	end
	
end


-- take control of capship if enter_station event is triggered and autocontrol is true
function T.Tab.autoControl(event, data)
	T.Tab.ship = unspickle(LoadSystemNotes(T.Tab.systemnotes));
	local stationType = GetStationType()
	if T.Tab.ship.autocontrolCapship == true and stationType ~= nil then
		ControlOwnCapship()
	end
end



local chatreceiver_old = chatreceiver.OnEvent
function chatreceiver:OnEvent(event, data)
	if event == "CHAT_MSG_PRINT" then
		local msg = data.msg
		if msg == "<CLICK!> Out of missiles!" then
			HUD:PrintSecondaryMsg("\127ffff8c<CLICK!> Out of missiles!\127o")
		else
			chatreceiver_old(chatreceiver, event, data) 
		end
	else 
        chatreceiver_old(chatreceiver, event, data) 
    end
end


-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\127ffff8cMDI-TargetList API version is not compatible. Capship Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\127ffff8cCapship Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end


RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
RegisterEvent(T.Tab.autoControl, "ENTERED_STATION")
RegisterUserCommand("capshipsetup", T.Tab.savemsg)